/// <summary> </summary>
using System;
using System.Reflection;

namespace org.solol.mmseg.core
{
	
	/// <author>  solo L
	/// 
	/// </author>
	public abstract class AlgorithmFactory
	{
		public static AlgorithmFactory Factory
		{
			get
			{
				if (factory == null)
				{
					factory = createFactory(FACTORY_DEFAULT);
				}
				
				return factory;
			}
			
		}
		
		public const System.String FACTORY_PROPERTY = "org.solol.mmseg.AlgorithmFactory";
		
		public const System.String FACTORY_DEFAULT = "org.solol.mmseg.AlgorithmFactoryImpl";
		
		private static AlgorithmFactory factory = null;
		
		protected internal static AlgorithmFactory createFactory(System.String factoryClass)
		{
            System.Type logFactoryClass=Type.GetType(factoryClass);
            try
			{
				return (AlgorithmFactory) System.Activator.CreateInstance(logFactoryClass);
			}
			
			catch (System.UnauthorizedAccessException e)
			{
				throw new ConfigurationException(e);
			}
            catch (System.Exception e)
            {
                throw new ConfigurationException(e);
            }
		}
		
		public abstract IAlgorithm createAlgorithm();
		
		public abstract IAlgorithm createAlgorithm(System.String type);
	}
}