/// <summary> </summary>
using System;
namespace org.solol.mmseg.core
{
	
	/// <author>  solo L
	/// 
	/// </author>
	public class MMSeg
	{
		
		private static AlgorithmFactory factory;
		
		public static System.String segment(System.String content)
		{
			return segment(content, Config.SINGLE_WORD);
		}
		
		public static System.String segment(System.String content, System.String type)
		{
			
			char[] chars = content.ToCharArray();
			
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			
			IAlgorithm algorithm = factory.createAlgorithm(type);
			//Set your AmbiguityHandler here.
			//algorithm.setAmbiguityHandler(ambiguityHandler);
			IWord word = algorithm.next(chars);
			
			while (word != null)
			{
				
				sb.Append(word.Value);
				sb.Append(Config.SEPARATOR);
				
				word = algorithm.next(chars);
			}
			
			return sb.ToString();
		}
		
		/// <param name="args">
		/// </param>
		[STAThread]
		public static void  Main(System.String[] args)
		{
			try
			{
				/*System.out.println("TEST MMRule:");
				System.out.println("Simple ->" + MMSeg.segment("ۿҪ"));
				System.out.println("Complex->"
				+ MMSeg.segment("ۿҪ", Config.THREE_WORD));
				System.out.println("Simple ->" + MMSeg.segment("ۿҪ"));
				System.out.println("Complex->"
				+ MMSeg.segment("ۿҪ", Config.THREE_WORD));
				System.out.println("Simple ->" + MMSeg.segment("ۿҪ"));
				System.out.println("Complex->"
				+ MMSeg.segment("ۿҪ", Config.THREE_WORD));
				System.out.println("Simple ->" + MMSeg.segment("ۿ"));
				System.out.println("Complex->"
				+ MMSeg.segment("ۿ", Config.THREE_WORD));
				System.out.println();
				System.out.println("TEST LAWLRule:");
				System.out.println("Simple ->" + MMSeg.segment("ʻ"));
				System.out.println("Complex->"
				+ MMSeg.segment("ʻ", Config.THREE_WORD));
				System.out.println();
				System.out.println("TEST SVWLRule:");
				System.out.println("Simple ->" + MMSeg.segment("оԴ"));
				System.out.println("Complex->"
				+ MMSeg.segment("оԴ", Config.THREE_WORD));
				System.out.println();
				System.out.println("TEST LSDMFOCWRule:");
				System.out.println("Simple ->" + MMSeg.segment("һ"));
				System.out.println("Complex->"
				+ MMSeg.segment("һ", Config.THREE_WORD));
				System.out.println();
				System.out.println("Simple ->"
				+ MMSeg.segment("Ҹոտʼɽг˶ʱҸԸѡپܼ򵥵г"));
				System.out.println("Complex->"
				+ MMSeg.segment("Ҹոտʼɽг˶ʱҸԸѡپܼ򵥵г",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("ԴһڱάϵԴϢԡ"));
				System.out.println("Complex->"
				+ MMSeg.segment("ԴһڱάϵԴϢԡ",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("RDFϢҪӦóǽʾ˹ۿĳϡ"));
				System.out.println("Complex->"
				+ MMSeg.segment("RDFϢҪӦóǽʾ˹ۿĳϡ",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("RDFṩһֻXML﷨ΪRDF/XMLڱͽRDFͼ"));
				System.out.println("Complex->"
				+ MMSeg.segment("RDFṩһֻXML﷨ΪRDF/XMLڱͽRDFͼ",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("20070808"));
				System.out.println("Complex->"
				+ MMSeg.segment("20070808",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("http://www.example.org/index.html has a creation-date whose value is August 16, 1999."));
				System.out.println("Complex->"
				+ MMSeg.segment("http://www.example.org/index.html has a creation-date whose value is August 16, 1999.",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("ͷպϣͽС"));
				System.out.println("Complex->"
				+ MMSeg.segment("ͷպϣͽС",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("ʩͷһġ"));
				System.out.println("Complex->"
				+ MMSeg.segment("ʩͷһġ",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("ˮƽ"));
				System.out.println("Complex->"
				+ MMSeg.segment("ˮƽ",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("Щҵйҵʮ"));
				System.out.println("Complex->"
				+ MMSeg.segment("Щҵйҵʮ",
				Config.THREE_WORD));
				System.out.println("Simple ->"
				+ MMSeg.segment("Щҵйҵʮ"));*/
				System.Console.Out.WriteLine("Complex->" + MMSeg.segment("Щҵйҵʮ", Config.THREE_WORD));
			}
			catch (AlgorithmException e)
			{
				SupportClass.WriteStackTrace(e, Console.Error);
			}
		}
		static MMSeg()
		{
			{
				try
				{
					factory = AlgorithmFactory.Factory;
				}
				catch (ConfigurationException e)
				{
					SupportClass.WriteStackTrace(e, Console.Error);
				}
			}
		}
	}
}