/// <summary> </summary>
using System;
using IChunk = org.solol.mmseg.core.IChunk;
using IWord = org.solol.mmseg.core.IWord;
namespace org.solol.mmseg
{
	
	/// <author>  solo L
	/// 
	/// </author>
	public sealed class Chunk : IChunk
	{
		public double AverageLength
		{
			/*
			* (non-Javadoc)
			* 
			* @see org.solol.mmseg.core.IChunk#getLargestAverageLength()
			*/
			
			get
			{
				if (averageLength == - 1D)
				{
					averageLength = (double) Length / (double) words.Length;
				}
				
				return averageLength;
			}
			
		}
		public double Variance
		{
			/*
			* (non-Javadoc)
			* 
			* @see org.solol.mmseg.core.IChunk#getSmallestVariance()
			*/
			
			get
			{
				if (variance == - 1D)
				{
					double tempVariance = 0D;
					for (int i = 0; i < words.Length; i++)
					{
						double temp = (double) words[i].Length - AverageLength;
						tempVariance += temp * temp;
					}
					
					variance = System.Math.Sqrt(tempVariance / (double) words.Length);
				}
				return variance;
			}
			
		}
		public IWord[] Words
		{
			/*
			* (non-Javadoc)
			* 
			* @see org.solol.mmseg.core.IChunk#getWords()
			*/
			
			get
			{
				return words;
			}
			
		}
		public int Length
		{
			get
			{
				if (length == - 1)
				{
					length = 0;
					for (int i = 0; i < words.Length; i++)
					{
						length += words[i].Length;
					}
				}
				
				return length;
			}
			
		}
		public double DegreeOfMorphemicFreedom
		{
			get
			{
				if (degreeMorphemicFreedom == - 1D)
				{
					degreeMorphemicFreedom = 0D;
					for (int i = 0; i < words.Length; i++)
					{
						if (words[i].Length == 1)
						{
							degreeMorphemicFreedom += System.Math.Log((double) words[i].Frequency);
						}
					}
				}
				return degreeMorphemicFreedom;
			}
			
		}
		
		private IWord[] words = null;
		
		private double averageLength = - 1D;
		
		private double variance = - 1D;
		
		private double degreeMorphemicFreedom = - 1D;
		
		private int length = - 1;
		
		public Chunk(IWord[] words)
		{
			this.words = words;
		}
	}
}