/// <summary> </summary>
using System;
using org.solol.mmseg;
using Config = org.solol.mmseg.core.Config;
using DictionaryFactory = org.solol.mmseg.core.DictionaryFactory;
using IDictionary = org.solol.mmseg.core.IDictionary;
namespace org.solol.mmseg
{
	
	/// <author>  solo L
	/// 
	/// </author>
	public class DictionaryFactoryImpl:DictionaryFactory
	{
		
		private IDictionary dictionary = null;
		
		public override IDictionary createDictionary()
		{
			if (dictionary == null)
			{
				dictionary = loadDictionary();
			}
			return dictionary;
		}
		
		private static IDictionary loadDictionary()
		{
			IDictionary dictionary = new Dictionary();
			System.String chars = "wordlist\\chars.lex";
			loadWords(chars, dictionary, "UTF-8");
			System.String words = "wordlist\\words.lex";
			loadWords(words, dictionary, "UTF-8");
			return dictionary;
		}
		
		private static void  loadWords(System.String fileName, IDictionary dictionary, System.String charSet)
		{
			System.IO.Stream is_Renamed = null;
			System.IO.StreamReader isr = null;
			System.IO.StreamReader br = null;
			
			try
			{
				is_Renamed = new System.IO.FileStream(fileName, System.IO.FileMode.Open, System.IO.FileAccess.Read);
				isr = new System.IO.StreamReader(is_Renamed, System.Text.Encoding.GetEncoding(charSet));
				br = new System.IO.StreamReader(isr.BaseStream, isr.CurrentEncoding);
				
				System.String word = null;
				
				while ((word = br.ReadLine()) != null)
				{
					
					if (word.IndexOf("#") == - 1)
					{
						if (word.IndexOf(" ") == - 1)
						{
							if (word.Length <= Config.WORD_MAX_LENGTH)
							{
								dictionary.addWord(word, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
							}
						}
						else
						{
							System.String value_Renamed = word.Substring(0, (word.IndexOf(" ")) - (0));
							if (value_Renamed.Length <= Config.WORD_MAX_LENGTH)
							{
								int frequency = System.Int32.Parse(word.Substring(word.IndexOf(" ") + 1, (word.LastIndexOf(" ")) - (word.IndexOf(" ") + 1)));
								dictionary.addWord(value_Renamed, frequency, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
							}
						}
					}
				}
			}
			catch (System.IO.IOException e)
			{
				SupportClass.WriteStackTrace(e, Console.Error);
			}
			finally
			{
				try
				{
					if (br != null)
					{
						br.Close();
					}
					if (isr != null)
					{
						isr.Close();
					}
					if (is_Renamed != null)
					{
						is_Renamed.Close();
					}
				}
				catch (System.IO.IOException e)
				{
					SupportClass.WriteStackTrace(e, Console.Error);
				}
			}
		}
	}
}