/// <summary> </summary>
using System;
using IChunk = org.solol.mmseg.core.IChunk;
using IRule = org.solol.mmseg.core.IRule;
namespace org.solol.mmseg
{
	
	/// <author>  solo L
	/// 
	/// </author>
	public class LSDMFOCWRule : IRule
	{
		
		/* (non-Javadoc)
		* @see org.solol.mmseg.core.IRule#invoke()
		*/
		public IChunk[] invoke(IChunk[] chunks)
		{
			LSDMFOCWRuleComparator[] orderedChunks = new LSDMFOCWRuleComparator[chunks.Length];
			
			for (int i = 0; i < chunks.Length; i++)
			{
				orderedChunks[i] = new LSDMFOCWRuleComparator(chunks[i]);
			}
			
			System.Array.Sort(orderedChunks);
			
			int index = 0;
			double degreeOfMorphemicFreedom = orderedChunks[index].Chunk.DegreeOfMorphemicFreedom;
			
			System.Collections.IList list = new System.Collections.ArrayList(1);
			list.Add(orderedChunks[index].Chunk);
			
			index++;
			
			while (index < orderedChunks.Length)
			{
				
				if (orderedChunks[index].Chunk.DegreeOfMorphemicFreedom == degreeOfMorphemicFreedom)
				{
					list.Add(orderedChunks[index].Chunk);
				}
				else
				{
					break;
				}
				index++;
			}
			
			IChunk[] degreeOfMorphemicFreedomChunks = new IChunk[list.Count];
			SupportClass.ICollectionSupport.ToArray(list, degreeOfMorphemicFreedomChunks);
			
			return degreeOfMorphemicFreedomChunks;
		}
		
		internal class LSDMFOCWRuleComparator : System.IComparable
		{
			virtual public IChunk Chunk
			{
				get
				{
					return chunk;
				}
				
			}
			
			private IChunk chunk;
			
			public LSDMFOCWRuleComparator(IChunk chunk)
			{
				this.chunk = chunk;
			}
			
			public virtual int CompareTo(System.Object obj)
			{
				IChunk another = ((LSDMFOCWRuleComparator) obj).Chunk;
				
				double temp = another.DegreeOfMorphemicFreedom - chunk.DegreeOfMorphemicFreedom;
				
				if (temp > 0D)
				{
					return 1;
				}
				else if (temp < 0D)
				{
					return - 1;
				}
				else
				{
					return 0;
				}
			}
		}
	}
}