/// <summary> </summary>
using System;
using IChunk = org.solol.mmseg.core.IChunk;
using IRule = org.solol.mmseg.core.IRule;
namespace org.solol.mmseg
{
	
	/// <author>  solo L
	/// 
	/// </author>
	public class SVWLRule : IRule
	{
		
		/*
		* (non-Javadoc)
		* 
		* @see org.solol.mmseg.core.IRule#invoke()
		*/
		public IChunk[] invoke(IChunk[] chunks)
		{
			SVWLRuleComparator[] orderedChunks = new SVWLRuleComparator[chunks.Length];
			
			for (int i = 0; i < chunks.Length; i++)
			{
				orderedChunks[i] = new SVWLRuleComparator(chunks[i]);
			}
			
			System.Array.Sort(orderedChunks);
			
			int index = 0;
			double smallestVariance = orderedChunks[index].Chunk.Variance;
			
			System.Collections.IList list = new System.Collections.ArrayList(1);
			list.Add(orderedChunks[index].Chunk);
			
			index++;
			
			while (index < orderedChunks.Length)
			{
				
				if (orderedChunks[index].Chunk.Variance == smallestVariance)
				{
					list.Add(orderedChunks[index].Chunk);
				}
				else
				{
					break;
				}
				index++;
			}
			
			IChunk[] smallestVarianceChunks = new IChunk[list.Count];
			SupportClass.ICollectionSupport.ToArray(list, smallestVarianceChunks);
			
			return smallestVarianceChunks;
		}
		
		internal class SVWLRuleComparator : System.IComparable
		{
			virtual public IChunk Chunk
			{
				get
				{
					return chunk;
				}
				
			}
			
			private IChunk chunk;
			
			public SVWLRuleComparator(IChunk chunk)
			{
				this.chunk = chunk;
			}
			
			public virtual int CompareTo(System.Object obj)
			{
				IChunk another = ((SVWLRuleComparator) obj).Chunk;
				
				double temp = chunk.Variance - another.Variance;
				
				if (temp > 0D)
				{
					return 1;
				}
				else if (temp < 0D)
				{
					return - 1;
				}
				else
				{
					return 0;
				}
			}
		}
	}
}