/// <summary> </summary>
using System;
using NUnit.Framework;
using Assert=NUnit.Framework.Assert;
using IChunk = org.solol.mmseg.core.IChunk;
using IWord = org.solol.mmseg.core.IWord;
using Chunk = org.solol.mmseg.Chunk;
using Word = org.solol.mmseg.Word;
namespace org.solol.mmseg.test
{
	
	/// <author>  solo L
	/// 
	/// </author>
	[TestFixture]
	public class ChunkTest:TestCase
	{
		
		/*
		* (non-Javadoc)
		* 
		* @see junit.framework.TestCase#setUp()
		*/
		protected internal virtual void  setUp()
		{
			
		}
		
		/*
		* (non-Javadoc)
		* 
		* @see junit.framework.TestCase#tearDown()
		*/
		protected internal virtual void  tearDown()
		{
		}
		
		/// <summary> Test method for
		/// {@link org.solol.mmseg.internal.Chunk#Chunk(org.solol.mmseg.core.IWord[])}.
		/// </summary>
		public void  testChunk()
		{
			
		}
		
		/// <summary> Test method for
		/// {@link org.solol.mmseg.internal.Chunk#getAverageLength()}.
		/// </summary>
		public void  testGetAverageLength()
		{
			IWord word1 = new Word("ʻ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word2 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word3 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word4 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word5 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IChunk chunk1 = new Chunk(new IWord[]{word1});
			IChunk chunk2 = new Chunk(new IWord[]{word2, word5});
			IChunk chunk3 = new Chunk(new IWord[]{word3, word4, word5});
			NUnit.Framework.Assert.IsTrue(3D == chunk1.AverageLength);
			NUnit.Framework.Assert.IsTrue(1.5D == chunk2.AverageLength);
			NUnit.Framework.Assert.IsTrue(1D == chunk3.AverageLength);
		}
		
		/// <summary> Test method for
		/// {@link org.solol.mmseg.internal.Chunk#getVariance()}.
		/// </summary>
		public void  testGetVariance()
		{
			IWord word1 = new Word("о", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word2 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word3 = new Word("Դ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word4 = new Word("о", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word5 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IChunk chunk1 = new Chunk(new IWord[]{word1, word2, word3});
			IChunk chunk2 = new Chunk(new IWord[]{word4, word5, word3});
			
			NUnit.Framework.Assert.IsTrue(0D == chunk1.Variance);
			NUnit.Framework.Assert.IsTrue(System.Math.Sqrt(2D / 3) == chunk2.Variance);
		}
		
		/// <summary> Test method for {@link org.solol.mmseg.internal.Chunk#getLength()}.</summary>
		public void  testGetLength()
		{
			IWord word1 = new Word("ʻ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word2 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word3 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word4 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word5 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IChunk chunk1 = new Chunk(new IWord[]{word1});
			IChunk chunk2 = new Chunk(new IWord[]{word2, word5});
			IChunk chunk3 = new Chunk(new IWord[]{word3, word4, word5});
			
			NUnit.Framework.Assert.AreEqual(3, chunk1.Length);
			NUnit.Framework.Assert.AreEqual(3, chunk2.Length);
			NUnit.Framework.Assert.AreEqual(3, chunk3.Length);
		}
		
		/// <summary> Test method for
		/// {@link org.solol.mmseg.internal.Chunk#getSumOfDegreeOfMorphemicFreedom()}.
		/// </summary>
		public void  testGetDegreeOfMorphemicFreedom()
		{
			IWord word1 = new Word("Ҫ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word2 = new Word("", 3200626, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word3 = new Word("Ϊ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word4 = new Word("", 224073, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word5 = new Word("Ҫ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IChunk chunk1 = new Chunk(new IWord[]{word1, word2, word3});
			IChunk chunk2 = new Chunk(new IWord[]{word4, word5, word3});
			
			NUnit.Framework.Assert.IsTrue(System.Math.Log((double) 3200626) == chunk1.DegreeOfMorphemicFreedom);
			NUnit.Framework.Assert.IsTrue(System.Math.Log((double) 224073) == chunk2.DegreeOfMorphemicFreedom);
		}
	}
}