using System;
using NUnit.Framework;
using AlgorithmFactory = org.solol.mmseg.core.AlgorithmFactory;
using Config = org.solol.mmseg.core.Config;
using IAlgorithm = org.solol.mmseg.core.IAlgorithm;
using IWord = org.solol.mmseg.core.IWord;
using Word = org.solol.mmseg.Word;
//using TestCase = junit.framework.TestCase;
namespace org.solol.mmseg.test
{
	[TestFixture]
	public class ComplexAlgorithmTest:TestCase
	{
		
		private IAlgorithm algorithm;
		[SetUp]
		protected  virtual void  setUp()
		{
			algorithm = AlgorithmFactory.Factory.createAlgorithm(Config.THREE_WORD);
		}
		
		protected  virtual void  tearDown()
		{
			
		}
		
		public void  testMMRule()
		{
			// MMRule -> Rule1
			System.String content = "ۿҪ";
			IWord word1 = new Word("ۿ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IWord word = algorithm.next(content.ToCharArray());
            NUnit.Framework.Assert.AreEqual(word1, word);
		}
		public void  testLAWLRule()
		{
			//		LAWLRule -> Rule2
			System.String content = "ʻ";
			IWord word1 = new Word("ʻ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IWord word = algorithm.next(content.ToCharArray());
            NUnit.Framework.Assert.AreEqual(word1, word);
		}
		[Test]
		public void  testSVWLRule()
		{
			//		SVWLRule -> Rule3
			System.String content = "оԴ";
			IWord word1 = new Word("о", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IWord word = algorithm.next(content.ToCharArray());
            NUnit.Framework.Assert.AreEqual(word1, word);
		}
		
		public void  testLSDMFOCWRule()
		{
			//		LSDMFOCWRule -> Rule4
			System.String content = "һ";
			IWord word1 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IWord word = algorithm.next(content.ToCharArray());
            NUnit.Framework.Assert.AreEqual(word1, word);
		}

        public void testLSDMFOCWRule2()
        {
            //		LSDMFOCWRule -> Rule4
            System.String content = "LatinLetterԴһڱάϵԴϢԡ";
            IWord word = algorithm.next(content.ToCharArray());
            while(word!=null)
            {
                Console.Write(word.Value);
                Console.Write("_");
                word = algorithm.next(content.ToCharArray());
            }
        }
	}
}