/// <summary> </summary>
using System;
using NUnit.Framework;
using IDictionary = org.solol.mmseg.core.IDictionary;
using IWord = org.solol.mmseg.core.IWord;
using Dictionary = org.solol.mmseg.Dictionary;
using Word = org.solol.mmseg.Word;
namespace org.solol.mmseg.test
{
	
	/// <author>  solo L
	/// 
	/// </author>
    [TestFixture]
	public class DictionaryTest
	{
        public DictionaryTest()
		{
			InitBlock();
		}
		private void  InitBlock()
		{
			word1 = new Word(word1Value, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			word2 = new Word(word2Value, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			word3 = new Word(word3Value, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			word4 = new Word(word4Value, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
		}
		
		internal IDictionary dictionary = new Dictionary();
		
		internal System.String word1Value = "";
		internal IWord word1;
		
		internal System.String word2Value = "";
		internal IWord word2;
		
		internal System.String word3Value = "ѧ";
		internal IWord word3;
		
		internal System.String word4Value = "ѧ";
		internal IWord word4;
		
		/* (non-Javadoc)
		* @see junit.framework.TestCase#setUp()
		*/
        [SetUp]
		protected  virtual void  setUp()
		{
			dictionary.addWord(word1Value, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			dictionary.addWord(word2Value, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			dictionary.addWord(word3Value, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
		}
		
		/* (non-Javadoc)
		* @see junit.framework.TestCase#tearDown()
		*/
		protected internal virtual void  tearDown()
		{
		}
		
		public void  testIsMatched()
		{
			Assert.IsTrue(dictionary.isMatched(word1Value));
			Assert.IsTrue(dictionary.isMatched(word2Value));
			Assert.IsTrue(dictionary.isMatched(word3Value));
			Assert.IsFalse(dictionary.isMatched(word4Value));
		}
		
		public void  testAddWord()
		{
			dictionary.addWord(word4Value, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			Assert.IsTrue(dictionary.isMatched(word4Value));
			dictionary.removeWord(word4Value);
			Assert.IsFalse(dictionary.isMatched(word4Value));
		}
		
		public void  testGetWord()
		{
			Assert.AreEqual(word1, dictionary.getWord(word1Value));
			Assert.AreEqual(word2, dictionary.getWord(word2Value));
			Assert.AreEqual(word3, dictionary.getWord(word3Value));
		}
		
		public void  testRemoveWord()
		{
			dictionary.addWord(word4Value, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			Assert.IsTrue(dictionary.isMatched(word4Value));
			dictionary.removeWord(word4Value);
			Assert.IsFalse(dictionary.isMatched(word4Value));
		}
	}
}