/// <summary> </summary>
using System;
//using TestCase = junit.framework.TestCase;
using NUnit.Framework;
using IChunk = org.solol.mmseg.core.IChunk;
using IRule = org.solol.mmseg.core.IRule;
using IWord = org.solol.mmseg.core.IWord;
using Chunk = org.solol.mmseg.Chunk;
using LAWLRule = org.solol.mmseg.LAWLRule;

using Word = org.solol.mmseg.Word;
namespace org.solol.mmseg.test
{
	
	/// <author>  solo L
	/// 
	/// </author>
	[TestFixture]
	public class LAWLRuleTest:TestCase
	{
		
		internal IChunk chunk1;
		
		internal IChunk chunk2;
		
		internal IChunk chunk3;

	
	    /// <summary> </summary>
		/// <seealso cref="junit.framework.TestCase.setUp()">
		/// </seealso>
		[SetUp]
		protected  virtual void  setUp()
		{
			IWord word1 = new Word("ʻ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word2 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word3 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word4 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word5 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			chunk1 = new Chunk(new IWord[]{word1});
			chunk2 = new Chunk(new IWord[]{word2, word5});
			chunk3 = new Chunk(new IWord[]{word3, word4, word5});
		}
		
		/// <summary> </summary>
		/// <seealso cref="junit.framework.TestCase.tearDown()">
		/// </seealso>
		protected  virtual void  tearDown()
		{
		}
		
		/// <summary> Test method for
		/// {@link org.solol.mmseg.internal.LAWLRule#invoke(org.solol.mmseg.core.IChunk[])}.
		/// </summary>
		public void  testInvoke()
		{
			IRule lawlRule = new LAWLRule();
			IChunk[] chunks = new IChunk[]{chunk1, chunk2, chunk3};
			IChunk[] lawlChunks = lawlRule.invoke(chunks);
			NUnit.Framework.Assert.AreEqual(chunk1, lawlChunks[0]);
		}
	}
}