using System;
using NUnit.Framework;
using IChunk = org.solol.mmseg.core.IChunk;
using IRule = org.solol.mmseg.core.IRule;
using IWord = org.solol.mmseg.core.IWord;
using Chunk = org.solol.mmseg.Chunk;
using LSDMFOCWRule = org.solol.mmseg.LSDMFOCWRule;
using Word = org.solol.mmseg.Word;
//using TestCase = junit.framework.TestCase;
namespace org.solol.mmseg.test
{
	[TestFixture]
	public class LSDMFOCWRuleTest:TestCase
	{
		
		protected internal virtual void  setUp()
		{
			
		}
		
		protected internal virtual void  tearDown()
		{
			
		}
		
		public void  testInvoke()
		{
			IWord word1 = new Word("Ҫ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word2 = new Word("", 3200626, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word3 = new Word("Ϊ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word4 = new Word("", 224073, org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word5 = new Word("Ҫ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IChunk chunk1 = new Chunk(new IWord[]{word1, word2, word3});
			IChunk chunk2 = new Chunk(new IWord[]{word4, word5, word3});
			
			IRule lsdmfocwRule = new LSDMFOCWRule();
			IChunk[] chunks = new IChunk[]{chunk1, chunk2};
			IChunk[] lsdmfocwChunks = lsdmfocwRule.invoke(chunks);
            NUnit.Framework.Assert.AreEqual(chunk1, lsdmfocwChunks[0]);
		}
	}
}