/// <summary> </summary>
using System;
using NUnit.Framework;
using IChunk = org.solol.mmseg.core.IChunk;
using IRule = org.solol.mmseg.core.IRule;
using IWord = org.solol.mmseg.core.IWord;
using Chunk = org.solol.mmseg.Chunk;
using MMRule = org.solol.mmseg.MMRule;
using Word = org.solol.mmseg.Word;
//using TestCase = junit.framework.TestCase;
namespace org.solol.mmseg.test
{
	
	/// <author>  solo L
	/// 
	/// </author>
	[TestFixture]
	public class MMRuleTest:TestCase
	{
		
		private IRule rule;
		
		/*
		* (non-Javadoc)
		* 
		* @see junit.framework.TestCase#setUp()
		*/
        [SetUp]
		protected  virtual void  setUp()
		{
			rule = new MMRule();
		}
		
		/*
		* (non-Javadoc)
		* 
		* @see junit.framework.TestCase#tearDown()
		*/
		protected  virtual void  tearDown()
		{
		}
		
		public void  testInvoke1()
		{
			IWord word1 = new Word("ʻ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word2 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word3 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word4 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word5 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IChunk chunk1 = new Chunk(new IWord[]{word1});
			IChunk chunk2 = new Chunk(new IWord[]{word2});
			IChunk chunk3 = new Chunk(new IWord[]{word3});
			IChunk chunk4 = new Chunk(new IWord[]{word4});
			IChunk chunk5 = new Chunk(new IWord[]{word5});
			
			IChunk[] chunk = rule.invoke(new IChunk[]{chunk1, chunk2, chunk3, chunk4, chunk5});
            NUnit.Framework.Assert.IsTrue(1 == chunk.Length);
            NUnit.Framework.Assert.AreEqual(chunk1, chunk[0]);
		}
		
		public void  testInvoke2()
		{
			IWord word1 = new Word("ۿ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word2 = new Word("Ҫ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word3 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IChunk chunk1 = new Chunk(new IWord[]{word1, word2, word3});
			
			IWord word4 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IChunk chunk2 = new Chunk(new IWord[]{word1, word2, word4});
			
			IWord word5 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word6 = new Word("Ҫ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IChunk chunk3 = new Chunk(new IWord[]{word1, word5, word6});
			
			IWord word7 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word8 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IChunk chunk4 = new Chunk(new IWord[]{word7, word8, word2});
			
			IChunk chunk5 = new Chunk(new IWord[]{word7, word8, word5});
			
			IChunk[] chunk = rule.invoke(new IChunk[]{chunk1, chunk2, chunk3, chunk4, chunk5});
            NUnit.Framework.Assert.IsTrue(1 == chunk.Length);
            NUnit.Framework.Assert.AreEqual(chunk1, chunk[0]);
		}
		
		public void  testInvoke3()
		{
			IWord word1 = new Word("о", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word2 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word3 = new Word("Դ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word4 = new Word("о", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			IWord word5 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IChunk chunk1 = new Chunk(new IWord[]{word1, word2, word3});
			IChunk chunk2 = new Chunk(new IWord[]{word4, word5, word3});
			
			IChunk[] chunk = rule.invoke(new IChunk[]{chunk1, chunk2});
            NUnit.Framework.Assert.IsTrue(2 == chunk.Length);
            NUnit.Framework.Assert.AreEqual(chunk1, chunk[0]);
            NUnit.Framework.Assert.AreEqual(chunk2, chunk[1]);
		}
	}
}