using System;
using NUnit.Framework;
using AlgorithmFactory = org.solol.mmseg.core.AlgorithmFactory;
using IAlgorithm = org.solol.mmseg.core.IAlgorithm;
using IWord = org.solol.mmseg.core.IWord;
using Word = org.solol.mmseg.Word;
//using TestCase = junit.framework.TestCase;
namespace org.solol.mmseg.test
{
	[TestFixture]
	public class SimpleAlgorithmTest:TestCase
	{
		
		private IAlgorithm algorithm;
		
        [SetUp]
		protected  virtual void  setUp()
		{
			algorithm = AlgorithmFactory.Factory.createAlgorithm();
		}
		
		protected internal virtual void  tearDown()
		{
		}
		
		public void  testNext()
		{
			System.String content = "ʻ";
			IWord word1 = new Word("ʻ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			
			IWord word = algorithm.next(content.ToCharArray());
			NUnit.Framework.Assert.AreEqual(word1, word);
		}
	}
}