/// <summary> </summary>
using System;
using NUnit.Framework;
using IWord = org.solol.mmseg.core.IWord;
using Word = org.solol.mmseg.Word;
//using TestCase = junit.framework.TestCase;
namespace org.solol.mmseg.test
{
	
	/// <author>  solo L
	/// 
	/// </author>
	[TestFixture]
	public class WordTest:TestCase
	{
		
		internal IWord word1 = null;
		internal IWord word2 = null;
		internal IWord word3 = null;
		
		/*
		* (non-Javadoc)
		* 
		* @see junit.framework.TestCase#setUp()
		*/
        [SetUp]
		protected  virtual void  setUp()
		{
			word1 = new Word("ʻ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			word2 = new Word("ʻ", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
			word3 = new Word("", org.solol.mmseg.core.IWord_Fields.CJK_WORD);
		}
		
		/*
		* (non-Javadoc)
		* 
		* @see junit.framework.TestCase#tearDown()
		*/
        [TearDown]
		protected  virtual void  tearDown()
		{
			word1 = null;
			word2 = null;
			word3 = null;
		}
		
		/// <summary> Test method for
		/// {@link org.solol.mmseg.internal.Word#Word(java.lang.String)}.
		/// </summary>
		public void  testWord()
		{
            NUnit.Framework.Assert.IsNotNull(word1);
			NUnit.Framework.Assert.IsNotNull(word2);
			NUnit.Framework.Assert.IsNotNull(word3);
		}
		
		/// <summary> Test method for {@link org.solol.mmseg.internal.Word#getLength()}.</summary>
		public void  testGetLength()
		{
            NUnit.Framework.Assert.AreEqual(3, word1.Length);
            NUnit.Framework.Assert.AreEqual(3, word2.Length);
            NUnit.Framework.Assert.AreEqual(2, word3.Length);
		}
		
		/// <summary> Test method for {@link org.solol.mmseg.internal.Word#getValue()}.</summary>
		public void  testGetValue()
		{
            NUnit.Framework.Assert.AreEqual("ʻ", word1.Value);
            NUnit.Framework.Assert.AreEqual("ʻ", word2.Value);
            NUnit.Framework.Assert.AreEqual("", word3.Value);
		}
		
		/// <summary> Test method for {@link org.solol.mmseg.internal.Word#equals()}.</summary>
		public void  testEquals()
		{

            NUnit.Framework.Assert.IsTrue(word1.Equals(word2));
            NUnit.Framework.Assert.IsTrue(word2.Equals(word1));

            NUnit.Framework.Assert.IsFalse(word1.Equals(word3));
            NUnit.Framework.Assert.IsFalse(word3.Equals(word1));
		}
		
		/// <summary> Test method for {@link org.solol.mmseg.internal.Word#getValue()}.</summary>
		public void  testHashCode()
		{
            NUnit.Framework.Assert.IsTrue(word1.GetHashCode() == word2.GetHashCode());
            NUnit.Framework.Assert.IsFalse(word1.GetHashCode() == word3.GetHashCode());
		}
	}
}